/* ufilter.h  Header for the routines used for dsp-10 filter design.
 * Initial write     RSL  16 Oct 00
 */

/* log2(x)=KLN2*ln(x) where KLN2=1/ln(2) and ln(x) in C syntax is log(x) */
#define  KLN2       1.44269504089

/* The next two items are for plotting the response of the equalizer. */
#define  NFREQ      128             /* 512 */
#define  PIONNFREQ  0.0245436926    /* 0.00613592315 */
/* Note - Because of complications in convolving in an equalizer,
 * the filters in the DSP-10 should generally be odd numbers of taps.
 * Because of that, this program only works with odd numbers, saving
 * the chore of checking whether even or odd.
 */
#define  AUD_TAPS_R  199            /* Taps in receiver audio FIR */
#define  HTAPS_R      99            /* (AUD_TAPS_R-1)/2 */
/* On the next, reduce very small epsilon to prevent sqrt(neg number) */
#define  SCALE_XI_R   2.5507601e-5   /* 199 taps, 1/(AUD_TAPS_R-1)^2-epsilon */
#define  FSAMPLE_R    9600.0

/* In the interest of expediancy, the transmit equalizer is separate
 * routines */
#define  AUD_TAPS_T  129            /* Taps in receiver audio FIR */
#define  HTAPS_T      64            /* (AUD_TAPS_T-1)/2 */
/* On the next, reduce very small epsilon to prevent sqrt(neg number) */
#define  SCALE_XI_T   6.10351e-5   /* 129 taps, 1/(AUD_TAPS_T-1)^2-epsilon */
#define  FSAMPLE_T    48000.0

extern void filter_design_modalbox(void);
extern int coef_raud_filter(double*, double*, int*, double*,
                            double, double, double, int*, int);
extern void filter_design_modalbox_t(void);
extern int coef_taud_filter(double*, double*, int*, double*,
                            double, int*, int);
void init_filr(void);
void init_filt(void);