/* Header file for UHFA.C, ver 1.0 26 Feb 97   RSL */
/* Revised modes w/LHL7, PUA43   23 Jan 00     RSL */

#define TRUE  1
#define FALSE 0
#define COM_PORT	COM2
#define BAUD_RATE	9600
#define COM_SETTINGS	(BITS_8 | STOP_1 | NO_PARITY)
#define ESC_CHAR	'$'	/* Was '1' */
#define SPACE		32
#define HYPHEN		45

/* Some numbers within '120 dB' of bottom */ 
#define D_TINY		1.0E12*DBL_MIN
/*   and of the top */
#define D_VBIG		1.0E-12*DBL_MAX

/* The following are the outlines of the boxes in screen coordinates */
#define X1L		128
#define X1R		639
#define Y1T		1
#define Y1B		129
#define X2L		128
#define X2R		639
#define Y2T		147
#define Y2B		479
#define S_METER_POS	197

#define BOTTOM_LINE	33
#define NO_CLIP		0
#define DO_CLIP		1

#define	CW		0
#define USB		1
#define LSB		2
#define FM		3
#define LHL7            4
#define PUA43           5
#define EME2		6
#define LTI		7
#define AM		8

#define VFO		1
#define MEM		0

/* For display_width:   */
#define FULL_FREQ	0
#define HALF_FREQ	1
#define LST_GMT		8

#define IO_LPT1		0X378
#define IO_LPT2		0X3BC

#define R1MHZ		0X08191UL	/*  19 bit R counter, P & C=1, 1MHz */
#define R5MHZ		0X087D1UL	/*   5 MHz ref freq, 1st LO synth */
#define R10MHZ		0X08FA1UL	/*   and 10 MHz */

#define	INIT_CW		0		/* Initialize Morse code routine */
#define	ADD_CH		1		/* Put char into cw buffer */
#define SEND_CW		2		/* Send a character if available */
#define SHOW_BUF        3		/* Display transmit buffer */

/* Windowing functions for spectral analysis */
#define NO_WINDOW	0
#define TUKEY25		1
#define HAMMING		2
#define BH92            3

#define UBLACK		0
#define UGREENBLACK	1
#define	UOLIVE		2
#define UGREENBLUE	3
#define UBLUE		4
#define ULIGHTPURPLE	5
#define UPURPLE		6
#define UPURPLERED	7
#define URED		8
#define ULIGHTRED	9
#define UORANGE		10
#define UBEIGE		11
#define UHEAVYYELLOW	12
#define UYELLOW		13
#define UPALEYELLOW	14
#define UWHITE		15

/* FLOW and FHIGH are spectral bin limits used to measure average spectrum
 * values for normalization and for determining analog gain changes.  Avoid too
 * low a FLOW due to 60 Hz interference, etc.
 */
#define	FLOW		50
#define	FHIGH		250

#define AUDIO_BAND      15

extern void update_data(void);
extern void prep_display(void);
extern void print_stars(void);
extern void draw_grid(void);
extern void sa_graph(void);
extern void mark_frequency(int);
extern void t_r_toggle(void);
extern void freq_box(void);
extern void new_freq(void);
extern void set_afgain(int);
extern void set_rfgain(void);
extern void set_mike_gain(void);
extern void set_fm_squelch(void);
extern void v2f(int);
extern void set_ttn(int);
extern void set_cwoffset(void);
extern void set_eme_doppler(void);
extern void show_er(void);
extern void set_fsk(int);
extern void set_xmit_power(void);
extern void set_contrast(void);
extern void set_brightness(void);
extern void set_window(void);
extern void set_if_bw(int);
extern void set_affilt_sw(void);
extern void set_affilt_select(void);
extern void set_delay_right(int);
extern void filter_design(void);
extern void select_denoise(void);
extern void set_denoise(void);
extern void annotate_af_filt(void);
extern void set_dot(void);
extern void set_display_width(void);
extern void set_disp_offset(int);
extern void set_db_div(int);
extern void set_noncohave(int);
extern void set_mode(int);
extern void set_code_nx2(void);
extern void set_8_16(int);		/* 0=set to 8 bit, 1=toggle 8/16 */
extern void set_data_save(void);
extern void show_1cur(void);
extern void show_2cur(void);
extern void disp_toggle(void);
extern void normalize_plot(int);	/* 0=clear, 1=15 second, 2=10 min */
extern void normalize(int);		/* Do the normalization calcs, 256 or 512 */
extern void lt_normalize(void);
extern void dofreqplot(int);
extern void fsk2sec(void);		/* Sends 2 sec fsk tone */
extern void set_clock(int);		/* Manual set of DSP clock (NOT PC clock) */
extern long int  update_clock(int);	/* Set/get start of next second */
extern void diagnostics(int);
extern void freq_data(int, long int, long int, long int, long int, long int,
               unsigned int);
extern void initialize(int);
extern void presets(void);
extern void do_transmit(void);
extern void eme_timing(void);		/* Poles eme_state after times all */
extern void lhl7_timing(void);
extern void do_auto_disp(int k);
extern int  read_config_file(void);
extern void save_state(void);
extern void new_vfo(int);
extern void new_band(int);
extern void rit_toggle(void);
extern void display_summary(char*, char*);
extern void print_time(void);
extern void send_shift_data(unsigned long);  /* Load shift regs and synth from dsp */
extern void tiny_time(int, int, int);
extern void tiny_char(int, int, int);
extern void micro_char(int, int, int);
extern void point1(int, int);
extern void point5(int, int);
extern void beep(int);
extern int  near_int(double);
extern void bar_graph(int, int, unsigned int, int);
extern int  get_kbd_int(void);
extern int  keyident(void);
extern void get_mem(void);
extern void set_agc(int);
extern void set_cw_speed(void);
extern void draw_panel(void);
extern double p2db(double);
extern double upow10(double);
extern void get_dsp_ptrs(void);
extern void get_dsp_mem(int what, int* tbl, int item, int offset);
extern void set_dsp_mem(int what, int adr, long int data);
extern int  get_status_bytes(int type, double timeout);
extern double update_moon(struct tm *ptm, int do_now);
extern void update_sun(struct tm *ptm, int do_now);
extern void set_cur_loc(int);
extern void set_bins(void);
extern void do_t_error(int, char*, int);

/*************************************************************************/

struct transverter_info
	{
	char	name[9];		/* Identifier, printed in upper-left */
	int	lo_type;		/* 0=open loop, 1=ref locked, 2=counter
					   Only 0 presently implemented */
	int	sb;			/* -1 if i-f=rf-lo, else 1 */
	double	lo_freq;		/* lo freq in Hz */
	int	chain_mult;		/* For counter, if sub-multiple of lo*/
	char	init_str[20];		/* Serial string for transverter init
					   or the string 'NULL' if not used.
					   Only NULL presently implemented */
	double	gain_db;		/* Used to make dBm, like 23.7 */
	int	control;		/* NU: for FM offset in kHz */
	unsigned bus_adr;		/* For controlling tvtr's */
	double	last_tfreq;		/* NU: Where last tuned */
	int	last_mode;		/* NU: Last mode used v3.28 */
	};

struct vfo_info
	{
	int	tvtr;			/* Associated transverter, 0 to 20 */
	int	tr_offset;		/* In kHz FM Offset */
	double	last_tfreq;		/* Where last tuned, Hz at 2-m I-F */
	int	last_mode;		/* Last mode used */
	int	t_fm_use;		/* 0=nu 1=DTMF 2=single tone */
	double	t_fm_freq;		/* 0.0 to 3500.0 Hz */
	int	t_fm_dur;		/* 0 to 9998 ms, 9999=continuous */
	int	t_fm_level;		/* 0 to 100 dB */
	int	par1;			/* Not used */
	int	par2;			/* Not used */
	};

struct rf_gn
	{
	double	dbgain;			/* 0.0 or less, 0.0 for [0] entry */
	int	gainbyte;		/* Gets ORed with shift_reg */
	int	dbdisplay;		/* 0 to 100, 100 for [0] entry (dB) */
	};

struct filter_info
	{
	char	name[7];		/* Identifier, printed on screen */
	char	file_name[31];		/* Extensions .fil and .dat */
	int	fil_type;		/* 0=Misc 1=Kaiser, 2=Parks-Mc,
					 * 3=McClure match, 4=Equalizer */
	double	param1;			/* Side lobe dB for Kaiser */
	double	param2;			/* NU */
	int	param3;			/* NU */
	int	fclow;			/* (0, 4800) */
	int	fchigh;			/* (0, 4800) */
	int	fil_gain;		/* Shifts inherent in coefs (0,15) */
	};

extern char		*big_area_ptr1;
extern char		*big_area_ptr2;
extern char		cc[];		/* General purpose string area */
extern char		version[];
extern int		contrast;
extern double		dis_gain;
extern int		bright;
extern double		dis_offset;
extern int		power_exp;  /*Power of 2 that dsp data is divided by
				      before integration; must be (0, 255).  */
extern int		scroll_line;
/* T/R is controlled either by PTT on rf board or by 'Home'. The following
   three variables allow either but not both at any time.   */
extern unsigned int	transmit;	/* 1=transmit, 0=receive */
extern unsigned int	ptt;		/* PTT: 1=transmit, 0=receive */
extern unsigned int	home_tr;	/* 'Home' key: 1=transmit, 0=receive */
extern unsigned int	cw_on;		/* 0=cw off, 1=cw on */
extern int	rfgain;			/* (0, 6) for 0, -6, ... -36 dB */
extern int	xmit_power;
extern int	mike_gain;
extern int	afgain;
extern int      deldb;			/* For up/down cursor keys */
extern int      deldb_sh;               /*  and when shift key is down */
extern int      mute;
extern int	fm_afgain;
extern int	bufcount;		/* Char count, CW, LHL7, etc */
extern int	cwoffset;
extern int	fsk;			/* Modulation tone for LHL7, PUA43 */
extern int	sidetone_lev;
extern int	fm_squelch;
extern double	fm_dev;
extern int	noncohave;
extern int      d_noncoh;
extern unsigned int fft_fcn;
extern int	fft_bw;
extern int	do_window;
extern int	do_window_save;
extern double win_adj;			/* Correctn for Hamming/BH-92 window */
extern int    do_af_filt;		/* 0=no filt, 1=af filt on */
extern int	af_coef;		/* 0=dsp coefs0, 1=coefs1 */
extern int    do_denoise;		/* 0=no denoise, 1=denoise on */
extern int	denoise_level;
extern int	denoise_decay;
extern int      do_LMS;
extern int      autonotch_level;
extern int	delay_state;		/* 0=No binaural delay */
extern int	delay_right;		/* Power of 2 x 20.8usec on right ch */
extern int	agc_decay;
extern int	dot_type;
extern int	display_width;
extern int	bin_low;		/* Lowest bin for marker */
extern int	db_div_set;		/* 0=10db/div, 1=5db, 2=2db, 3=1db */
extern double	kdb_div;		/* 80 div/256 values */
extern double	koffset;		/* Display offset in dB */
extern int	mode;
extern int	binaural;
extern int	iq;
extern int	bits_8_16;		/* 0=8 bit log data, 1=16 bit */
extern int	hardware;		/* RF Hardware present */
extern int	normalize_on;		/* 0=off, 1=on, >1 is countdown */
extern int	auto_disp_on;		/* 0=off, 1=on  */
extern int	rit;
extern int	rit_save;
extern int	rit_on;
extern int	band;				/* Band 1 = 144 MHz */
extern long	tfreqL;
extern long     delf, delf_sh;		/* For L/R cursor keys */
extern struct	 palettetype  upalette;
extern int	startup_detail;		/* 0=No detail, 1=Show diagnostics
					   Set =1 in case .cfg missing */
extern int	waterfall;		/* 0=Fancy freq dial, 1=Waterfall */
extern int	time_type;		/* 0=GMT, 1=local */
extern unsigned char code_id[];        /* ID when sending fsk code */
extern int	code_nx2;		/* Number of 2 sec per tone */
extern double  millisec;		/* Corrected count of millisec */
extern double  millisec_offset;	/* Used in clock setting to line up
					   ticks */
extern double  clock_cor_factor;	/* Relative speed of PC clock */
extern long int  dsp_clock_base;	/* Offset to make millisec valid */
extern long int  cl_ms;		/* Results from last clock() */
extern int	clock_been_set;		/* Error for codes, if not set */
extern int	quit_save_state;	/* TRUE=save state on quit() */
extern int	beep_on_error;		/* When error codes are displayed */
extern int	error_on_tr;		/* Prevent error after T/R change */
extern int	data_omit_tr;		/* Reset value (CFG) for above */
extern struct	transverter_info tvtr[];
extern struct	vfo_info  vfo[];
extern int	cur_vfo;
extern int	cur_mem;		/* -1 if no memory selected */
extern int	v_m;			/* 1=VFO 0=MEM
extern unsigned int	dsp_deltap_lo;	/* Phase incr dsp, low 8 bits */
extern unsigned int	dsp_deltap_hi;	/* Phase incr dsp, high 8 bits */
extern int	dsp_status[];
extern int	dsp_xmit_status[];
extern double	ave_spectral_pwr;	/* Ave if color agc on */
extern double	ref_offset;		/* Correction factor for freq ref */
extern int	integrate_count;	/* Varies from 0 to noncohave/6  */
extern int	contrast_line_count;	/* Display contrast line if >0 */
extern int	cw_speed;		/* Index of speed (0, 25) */
extern int	cw_longkey;		/* ~ in CW send, log key down time */
extern int	display_error_count;
extern int	diag_mode;		/* 0=none, 1=text, 2=bargraphs
					   3=Moon/Sun data */
extern int	do_data_save;		/* 0=no save to file, 1=save */
extern unsigned int  com_port;

extern int      deflt_drv;

extern struct  palettetype  savpalette;

extern int c_background;
extern int c_outline;
extern int c_outline_bold;
extern int c_outline_bright;
extern int c_text;
extern int c_text_bold;
extern int c_text_bright;
extern int c_text_note;
extern int c_plot_bold;
extern int c_plot_bright;
extern int c_plot_marker;
extern int c_bar_dark;
extern int c_bar_low;
extern int c_bar_medium;
extern int c_bar_high;

extern double   noise_bw[];
extern int	incount;
extern double far fgain[];		/* 'Exact' gain value */
extern int far	fgainl[];		/* Low 8 bits of gain value */
extern int far	fgainh[];		/*   and high 8 bits */
extern int far	raw_data[];
extern double*	dnorm;
extern double*	lt_dnorm;
extern double	normalize_num;
extern double   eme2_te;		/* Effective Noise Temp Kelvins */
extern double*	pwrdat;			/* An array of 515 for power from
					   dsp fft.  Uses calloc() */
extern double*	pd16;			/* An array of power for 16 bit data */
extern double	pave;
extern double	paveave;		/* Rng ave of pave */
extern double*  lt_pwrdat;		/* 'Perpetual' power accumulation */
extern double	lt_max;			/* Limits of displayed integrated */
extern double	lt_min;			/*   power for scaling display */
extern int	lterm_dorandom;
extern double*	power10;		/* 256 entry table for converting log
					   to power. Uses calloc() */
extern char*    cwmbuf;			/* 10*50 char buffer, calloc() */
extern char	fscreen_path[];		/* Path for screen save files */
extern char	fdata_path[];		/* Path for data save files */
extern FILE*	data_file;
extern FILE*	config_file;
extern FILE*    license_file;

extern int	memch_stn;  // Station definition, such as code_id, call_str
extern int	memch_fr_md; // Freq & mode (conventional memory)
extern int	memch_radio; // Transceiver settings, special mode settings
extern int	memch_vfo;  // VFO (freq and mode) definitions (all 21)
extern int	memch_tvtr; // Transverter definitions (all 21, active or not)
extern int	memch_disp; // Display character, except colors
extern int	memch_bcn;  // Beacon operation
extern int	memch_fil;  // Filters, equalizers
extern int	memch_sys;  // System parameters: startup_detail,file paths,etc
extern int	memch_color; // Display colors
extern int	memch_hdw;  //Hardware, such as ezkit_dfreq, and pc clock
extern int	memch_kbd;   //Keyboard definitions

extern char	mem_name[];	// Short name string ptr
extern char 	mem_descr[];	// Description string ptr
extern int	mem_incl_fr_md; // Carries need for updating freq and mode

extern struct rf_gn  rfg[];
extern double	gain_adj;		/* dB factor to correct pwr disp */
extern int	screen_save;
extern struct	eenv  cur_env;		/* Cur enviornment:day, nutation, etc*/
extern int	ms_available;		/* TRUE if PC has millisec clock */
extern int	ut_available;		/* 0 if not avail, else 1 */
extern double	ut;			/* UT for moonsun calculations */
extern struct   tm    tdt;		/* TDT for ephemeris */
extern double	f_eme;			/* Dopplr Fr (audio processing only) */

/* For LHL7 mode, these variables:  */
extern struct	lhl  lc0;		/* Info on LHL codes from u_code */
extern int	lhl_bins;		/* 1, 3, 5, 7, or 9 to look over */
extern int	lhl_peak_ave;		/* Look for peak (=0) or ave (=1) */
extern int	lhl7_2line;		/* 0-->1 big line, 1-->2 small lines */

/* For PUA43, we need: */
extern int	pua14_28;
extern int	pua43_dorandom;
extern double	pua43_noisedecay;
extern double	pua43_colorscale;
extern int	code_min;		/* Minute of day (0, 1439) */
extern int*	pua43_rnd;		/* Array of 1440 random num */
extern char	pua43_xstring[];	/* 14 or 28 characters to be sent */
/* The following two parameters specify the PUA43 frequency arrangement
 * as a function of the fft_bw parameter.     */
extern double	df[];			/* Bin size, Hz, [fft_bw] */
extern int	b0[];			/* Base bin for PUA43, [fft_bw] */

extern double*	pua43_tune;
extern int	ptune0[];
extern int	ptune1[];
extern int	ptunec[];

/* Moon-Sun: */
extern struct	location loc[];
extern int	cur_loc;
extern struct	eenv cur_env;		/* Cur enviornment:day, nutation, etc*/
extern int	ut_available;		/* 0 if not avail, else 1 */
extern double	ut;			/* UT for moonsun calculations */
extern double   dut1;			/* UT1-UTC if known, else 0.0 */
extern struct  tm   tdt;		/* TDT for ephereris calculations */
extern double	f_eme;			/* Dopplr Fr (audio processing only) */
extern int show_secs;
extern int far  bar_color[];
extern int far  bar_color_o[];

/* For EME2 mode we need:    */
extern long int    eme_pulse_count;	/* The number of 5 second periods */
extern double      eme_pwr_sum[];	/* Long term pwr +/- 10 bins */
extern int         eme_freq_ctrl;	/* 0=fixed, 1=low noise, 2=random */
extern int         eme_doppler;		/* 0=no correct, 1=track doppler */
extern int         eme_state;		/* 0=clear, 1=standby, 2=active */
extern int         eme_record;		/* 0=off, 1=21 freq every 5 sec */
extern int         eme_delay;
extern int         eme2_format;		/* Bit  0: 1=doppler correct
					 *      1: 1=use random freq
					 *      2: 1=use auto noise blanker */
extern double	   eme_dop1, eme_dop2;	/* Due to E-M move, rotation */
extern double	   eme_dop3, eme_dop4;	/* Due to RA move, Dec move */
extern double      eme_freq_range;	/* Spread of EME2 frequencies */
extern double      code_nb_ratio;	/* Max noise/ave noise (NBlank) */
extern double      min_lt_dd;		/* Lowest div/db for "yelow" displays*/
/* Parameters for USB long term integration */
extern int         lterm_int;		/* TRUE or FALSE */
extern double      lterm_int_flow;	/* in Hz */
extern double      lterm_int_fhigh;
extern double      lterm_int_center;
extern double      lti_freq_range;	/* Random spread LTI */
extern double      lti_frandom;          /* Actual current random delta f */

/* Bin numbers for lomg term integration in USB and EME2: */
extern int         lt_i1, lt_i2, lt_i3, lt_i4, lt_i5;

/* Parameters for beacon operation */
extern int beacon, b_offset_sec, b_transmit_sec, b_receive_sec;
extern int b_active1, b_active2;
extern int b_repeat60;			/* 0=30 min repeat, 1=60 min repeat */
extern int lt_b_save, lt_b_save_bins, lt_b_clear;

/* Parameters for noise measurement */
extern int	np_record;
extern double	np1;
extern double	np2;
extern int	np_on;			/* 0=OFF, 1=ON */
extern int	np_state;		/* 0 or 1 for two measurements */
extern int	np_delay;		/* Milliseconds of delay for relays */

extern int	v2f_on;			/* 1=using V2F */
extern int	v2f_noise;		/* 1=using noise, 0=using signal */
extern int	v2f_pkave;		/* 0=ave sig, 1=peak sig */
extern double	v2f_tc;			/* Seconds */
extern double	v2f_gain;		/* Hz per dB */
extern double	v2f_basef;		/* Frequency for reset */
extern int	v2f_bin_low;		/* Signal measurement 0,511 */
extern int	v2f_bin_high;		/* Signal measurement */
extern double	v2f_freq_low;		/* Signal measurement 0.0,4800.0 */
extern double	v2f_freq_high;		/* Signal measurement */
extern int	v2f_af_level;		/* 0 to 99 */

extern int	dtmf_level;
extern int	dtmf_length;
#define FMTONE_NO 0
#define FMTONE_DTMF 1
#define FMTONE_TONE 2
extern	int	tone_fm_use;		/* Transmit FM NO, DTMF, TONE */
extern	double	tone_fm_freq;		/* This is CTCSS, or Beep */
extern	int	tone_fm_dur;		/* millisec, 9999=continuous */
extern	int	tone_fm_level;
extern	int	beep_use;		/* SSB end of xmit beep */
extern	double	beep_freq;
extern	int	beep_dur;
extern	int	beep_level;		/* Level rel to CW pwr 100=full CW */

extern int	ttn_control;
extern double   ttn_freq1, ttn_freq2;
extern int	ttn_level1, ttn_level2;

extern unsigned int mat_err;		/* Matrix calculation errors */

extern long int    random_freqL;

extern struct filter_info filt[];	/* Audio filters 0 to 7 */
extern double  flow;			/* Parameters for filter design */
extern double  fhigh;
extern double  kaiser_db;
extern int     fil8_use;
extern char    fil8_name[];
/* Parameters for receive equalizer that is part of filter design: */
#define	NFRB	15			/* Num Break freqs, (not progrmabl) */
extern double feqr[];			/* Equalizer break freqs, normalized */
/* Relative equalizer gains in dB (program from .cfg file): */
extern double aeqrdb[];

/* Parameters for transmit mike equalizer: */
#define	NFTB	8			/* NumBreak frequencies (not progrmabl) */
extern double feq_t[];			/* Equalizer break freq, normalized */
/* Relative equalizer gains in dB (program from .cfg file, or dialog box): */
extern double aeqdb_t[];

extern void*       current_info_box;    /* 0 if no box, otherwise ptr */

extern int far dsp_ptr[];		/* Table of pointers in DSP pm() */
extern int dsp_data_index;		/* Keeps track of data from DSP */
extern int table_adr;			/* DSP adr of ptr table, =0 if error */

extern int scsave;
extern int scs_key;
extern int use_scs_box;			/* TRUE if comment box at screen save*/

extern double ezkit_dfreq;
extern unsigned int shift_reg;
extern int dly_ant2amp;
extern int dly_amp2xmit;
extern int dly_xmit2amp;
extern int dly_amp2ant;
extern int dly_emet2r;
extern char time_str[];
extern int tick_time;
extern int pua43_tick;
extern char call_str[];
extern char file_ident[];
extern char f_path[];
extern int lpt_port;
extern int filter_mask;
extern double knoise;
extern double kfilt;
extern int denoise_del_len;
extern double freq_low;
extern int mode_mask;
extern int last_agc;
extern int fft_bw_save;
extern int hardware_ptt;

/* For signal simulation capability */
extern double xsnr, xfade_rate;
extern int xnoise, xfade;

extern unsigned int errcode;
extern int   kbd_alt1;
extern int   kbd_alt2;
extern int   kbd_alt3;

extern struct lbox_info lb_freq; 		/* Freq info box */
extern struct lbox_info lb_eme2;		/* EME2 data summary box */
extern struct lbox_info lb_lhl7;		/* and for LHL7 */
extern struct lbox_info lb_pua43;		/* and for PUA43 */
extern struct lbox_info lb_lterm_int;		/* and for LTI */
extern void* current_info_box;			/* 0 if no box, else ptr */

/* The following are the keyboard settings */
extern long int k_freq_m1;
extern long int k_freq_p1;
extern long int k_freq_m10;
extern long int k_freq_p10;
extern long int k_freq_m100;
extern long int k_freq_p100;
extern long int k_freq_m1k;
extern long int k_freq_p1k;
extern long int k_freq_m10k;
extern long int k_freq_p10k;
extern long int k_freq_m100k;
extern long int k_freq_p100k;
extern long int k_freq_m1mhz;
extern long int k_freq_p1mhz;
extern long int k_af_gain_m;
extern long int k_af_gain_p;
extern long int k_af_gain_m1;
extern long int k_af_gain_p1;
extern long int k_rf_gain_m;
extern long int k_rf_gain_p;
extern long int k_mike_gain_m;
extern long int k_mike_gain_p;
extern long int k_fm_squelch_m_c;
extern long int k_fm_squelch_m_l;
extern long int k_fm_squelch_p_c;
extern long int k_fm_squelch_p_l;
extern long int k_cw_speed_m;
extern long int k_cw_speed_p;
extern long int k_cw_buf_clr;
extern long int k_brite_m;
extern long int k_brite_p;
extern long int k_contrast_m;
extern long int k_contrast_p;
extern long int k_af_filter_t;
extern long int k_af_filter_s;
extern long int k_denoise_t;
extern long int k_denoise_m;
extern long int k_denoise_p;
extern long int k_nc_ave_m;
extern long int k_nc_ave_p;
extern long int k_delay_t_l;
extern long int k_delay_t_c;
extern long int k_rit_m_c;
extern long int k_rit_m_l;
extern long int k_rit_p_c;
extern long int k_rit_p_l;
extern long int k_rit_m1_c;
extern long int k_rit_m1_l;
extern long int k_rit_p1_c;
extern long int k_rit_p1_l;
extern long int k_rit_o_c;
extern long int k_rit_o_l;
extern long int k_rit_z_c;
extern long int k_rit_z_l;
extern long int k_norm_qck_c;
extern long int k_norm_qck_l;
extern long int k_norm_prc_c;
extern long int k_norm_prc_l;
extern long int k_color_agc_c;
extern long int k_color_agc_l;
extern long int k_gif_c;
extern long int k_gif_l;
extern long int k_beacon_c;
extern long int k_beacon_l;
extern long int k_record_c;
extern long int k_record_l;
extern long int k_window_t_c;
extern long int k_window_t_l;
extern long int k_fftbw_c;
extern long int k_fftbw_l;
extern long int k_emedop_c;
extern long int k_emedop_l;
extern long int k_mode_s_c;
extern long int k_mode_s_l;
extern long int k_binaural_t;
extern long int k_disp_t_c;
extern long int k_disp_t_l;
extern long int k_db_div;
extern long int k_offset_m;
extern long int k_offset_p;
extern long int k_freq_box;
extern long int k_save_cfg;
extern long int k_cas1;
extern long int k_cas2;
extern long int k_cas3;
extern long int k_cas4;
extern long int k_cas5;
extern long int k_cas6;
extern long int k_cas7;
extern long int k_cas8;
extern long int k_cas9;
extern long int k_cas0;
extern long int k_dafgd;
extern long int k_dafgu;
extern long int k_dfreqd;
extern long int k_dfrequ;
extern long int k_mute;
extern long int k_sh_dafgu;
extern long int k_sh_dafgd;
extern long int k_sh_dfrequ;
extern long int k_sh_dfreqd;
extern long int k_fil96;
extern long int k_dos_visit;
extern long int k_t_r_tog;
extern long int k_help;
extern long int k_code_data_c;
extern long int k_code_data_l;
extern long int k_code_change_c;
extern long int k_code_change_l;
extern long int k_clr_lt_c;
extern long int k_clr_lt_l;
extern long int k_clr_ylw_c;
extern long int k_clr_ylw_l;
extern long int k_flat_c;
extern long int k_flat_l;
extern long int k_vcur1_c;
extern long int k_vcur1_l;
extern long int k_vcur2_c;
extern long int k_vcur2_l;
extern long int k_set_clock_c;
extern long int k_set_clock_l;
extern long int k_eme_prev;
extern long int k_eme_next;
extern long int k_beacon_box;
extern long int k_tone_box;
extern long int k_diag_s;
extern long int k_af_filter_design;
extern long int k_xmt_eq_design;
extern long int k_sig_sim;
extern long int k_pua_del;
extern long int k_agc_decay_m;
extern long int k_agc_decay_p;
extern long int k_agc_decay_m_l;
extern long int k_agc_decay_p_l;
extern long int k_cwoffset_m;
extern long int k_cwoffset_p;
extern long int k_cwoffset_m_l;
extern long int k_cwoffset_p_l;
extern long int k_sidetone_lev_m;
extern long int k_sidetone_lev_p;
extern long int k_sidetone_lev_m_l;
extern long int k_sidetone_lev_p_l;
extern long int k_xmt_power_m;
extern long int k_xmt_power_p;
extern long int k_xmt_power_m_l;
extern long int k_xmt_power_p_l;
extern long int k_do_quit;
extern long int k_warm_boot;
extern long int k_band_50_a;
extern long int k_band_144_b;
extern long int k_band_220_c;
extern long int k_band_432_d;
extern long int k_band_902_9;
extern long int k_band_1296_e;
extern long int k_band_2304_f;
extern long int k_band_3456_g;
extern long int k_band_5760_h;
extern long int k_band_10k_i;
extern long int k_band_24k_j;
extern long int k_band_47k_k;
extern long int k_band_75k_l;
extern long int k_band_119k_m;
extern long int k_band_145k_n;
extern long int k_audio_o;
extern long int k_band_memo_1;
extern long int k_band_memo_2;
extern long int k_band_memo_3;
extern long int k_band_memo_4;
extern long int k_band_memo_5;
extern long int k_v2f_tog_c;
extern long int k_v2f_tog_l;
extern long int k_v2f_res_c;
extern long int k_v2f_res_l;
extern long int k_v2f_lbox_c;
extern long int k_v2f_lbox_l;
extern long int k_memw_c;
extern long int k_memw_l;
extern long int k_memr_c;
extern long int k_memr_l;
extern long int k_mem2vfo_c;
extern long int k_mem2vfo_l;
extern long int k_memlist_c;
extern long int k_memlist_l;

/* Keys for the clock-set modal box */
extern unsigned int ky_clock_m1s;
extern unsigned int ky_clock_p1s;
extern unsigned int ky_clock_m10ms;
extern unsigned int ky_clock_p10ms;
extern unsigned int ky_clock_mrate;
extern unsigned int ky_clock_prate;
extern unsigned int ky_clock_resync;
extern unsigned int ky_clock_exit;

extern unsigned int ky_v2f_base;
extern unsigned int ky_v2f_gainp;
extern unsigned int ky_v2f_gainm;
extern unsigned int ky_v2f_tcp;
extern unsigned int ky_v2f_tcm;
extern unsigned int ky_v2f_freqp;
extern unsigned int ky_v2f_freqm;

extern unsigned int ky_v2f_afp;
extern unsigned int ky_v2f_afm;
