/* Header file defining keys for commands in UHFA.C v1.0 26 Feb 97
   to V1.61 3 Feb 00, V2.0 15 Jan 01    RSL */

#define FREQ_M1		0XD7000		/* Ctrl Alt Sh F9	*/
#define FREQ_P1		0XD7100		/* Ctrl Alt Sh F10	*/
#define FREQ_M10	0X4300		/* F9			*/
#define FREQ_P10	0X4400		/* F10			*/

#define FREQ_M100	0X15C00		/* Shift F9		*/
#define FREQ_P100	0X15D00		/* Shift F10		*/

#define FREQ_M1K	0X87000		/* Alt F9		*/
#define FREQ_P1K	0X87100		/* Alt F10		*/

#define FREQ_M10K	0X46600		/* Ctrl F9		*/
#define FREQ_P10K	0X46700		/* Ctrl F10		*/
#define FREQ_M100K	0XC7000		/* Ctrl Alt F9		*/
#define FREQ_P100K	0XC7100		/* Ctrl Alt F10		*/
#define FREQ_M1MHZ	0X56600		/* Ctrl Sh F9		*/
#define FREQ_P1MHZ	0X56700		/* Ctrl Sh F10		*/

#define	AF_GAIN_M	0X4100		/* F7			*/
#define	AF_GAIN_P	0X4200		/* F8			*/
#define AF_GAIN_M1	0X46400		/* Ctrl F7		*/
#define AF_GAIN_P1	0X46500		/* Ctrl F8		*/
#define	RF_GAIN_M	0X15A00		/* Shift F7		*/
#define	RF_GAIN_P 	0X15B00		/* Shift F8		*/
#define	A_RF_GAIN_M	0X104100	/* Scrl F7 w/ kbd_alt3	*/
#define	A_RF_GAIN_P	0X104200	/* Scrl F8 w/ kbd_alt3	*/
#define	MIKE_GAIN_M	0X96E00		/* Alt Sh F7		*/
#define	MIKE_GAIN_P	0X96F00		/* Alt Sh F8		*/

#define	FM_SQUELCH_M_C	0X91F00		/* Alt S		*/
#define	FM_SQUELCH_M_L	0X81F00		/* Alt s		*/
#define	FM_SQUELCH_P_C	0X92000		/* Alt D		*/
#define	FM_SQUELCH_P_L	0X82000		/* Alt d		*/

#define	CW_SPEED_M	0X86E00		/* Alt F7		*/
#define	CW_SPEED_P	0X86F00		/* Alt F8		*/
#define CW_BUF_CLR	0X15300		/* Shift DEL		*/

#define	BRITE_M		0X3F00		/* F5			*/
#define	BRITE_P		0X4000		/* F6			*/
#define	CONTRAST_M	0X15800		/* Sh F5		*/
#define	CONTRAST_P 	0X15900		/* Sh F6		*/

#define	AF_FILTER_T	0X3D00		/* F3			*/
#define	AF_FILTER_S	0X3E00		/* F4			*/
#define	DENOISE_T	0X15600		/* Sh F3		*/
#define	DENOISE_M	0X46000		/* Ctrl F3		*/
#define	DENOISE_P	0X46100		/* Ctrl F4		*/
#define	NC_AVE_M	0X86A00		/* Alt F3		*/
#define	NC_AVE_P	0X86B00		/* Alt F4		*/
#define	DELAY_T_L	0X81200		/* Alt e		*/
#define	DELAY_T_C	0X91200		/* Alt E		*/

#define	RIT_M_C		0X91300		/* Alt R		*/
#define	RIT_M_L		0X81300		/* Alt r		*/
#define	RIT_P_C		0X91400		/* Alt T		*/
#define	RIT_P_L		0X81400		/* Alt t		*/
#define	RIT_M1_C	0XD1300		/* Ctrl Alt R		*/
#define	RIT_M1_L	0XC1300		/* Ctrl Alt r		*/
#define	RIT_P1_C	0XD1400		/* Ctrl Alt T		*/
#define	RIT_P1_L	0XC1400		/* Ctrl Alt t		*/
#define	RIT_O_C		0X91800		/* Alt O		*/
#define	RIT_O_L		0X81800		/* Alt o		*/
#define	RIT_Z_C		0X92C00		/* Alt Z		*/
#define	RIT_Z_L		0X82C00		/* Alt z		*/

#define	NORM_QCK_C	0X91000		/* Alt Q		*/
#define	NORM_QCK_L	0X81000		/* Alt q		*/
#define	NORM_PRC_C	0X91900		/* Alt P		*/
#define	NORM_PRC_L	0X81900		/* Alt p		*/

#define	COLOR_AGC_C	0X92E00		/* Alt C		*/
#define	COLOR_AGC_L	0X82E00		/* Alt c		*/

#define	GIF_C		0X92200		/* Alt G		*/
#define	GIF_L		0X82200		/* Alt g		*/

#define	BEACON_C	0X92300		/* Alt H		*/
#define	BEACON_L	0X82300		/* Alt h		*/

#define	RECORD_C	0X92100		/* Alt F		*/
#define	RECORD_L	0X82100		/* Alt f		*/

#define	WINDOW_T_C	0X91100		/* Alt W		*/
#define	WINDOW_T_L	0X81100		/* Alt w		*/
#define	A_WINDOW_T_C	0X111157	/* Alt W w/ kbd_alt2	*/
#define	A_WINDOW_T_L	0X101177	/* Alt w w/ kbd_alt2	*/

#define	FFTBW_C		0X92400		/* Alt J		*/
#define	FFTBW_L		0X82400		/* Alt j		*/

#define	EMEDOP_C	0X92600		/* Alt L		*/
#define	EMEDOP_L	0X82600		/* Alt l		*/

#define	MODE_S_C	0X93200		/* Alt M		*/
#define	MODE_S_L	0X83200		/* Alt m		*/

#define NARROW_T	0X97F00		/* Alt *		*/
#define BINAURAL_T	0X98000		/* Alt (		*/
#define IQ_T		0X98100		/* Alt )		*/

#define DISP_T_C	0X91500		/* Alt Y		*/
#define DISP_T_L	0X81500		/* Alt y		*/
#define	A_DISP_T_C	0X111559	/* Alt Y w/ kbd_alt2	*/
#define	A_DISP_T_L	0X101579	/* Alt y w/ kbd_alt2	*/

#define	INPUT_S_C	0X91700		/* Alt I		*/
#define	INPUT_S_L	0X81700		/* Alt i		*/
#define	A_INPUT_S_C	0X111749	/* Alt I w/ kbd_alt2	*/
#define	A_INPUT_S_L	0X101769	/* Alt i w/ kbd_alt2	*/

#define	DB_DIV		0X87800		/* Alt 1		*/

#define	OFFSET_M	0X87900		/* Alt 2		*/
#define	OFFSET_P	0X87A00		/* Alt 3		*/

#define	ALT4		0X87B00		/* Alt 4		*/
#define	ALT5		0X87C00		/* Alt 5		*/
#define	ALT6		0X87D00		/* Alt 6		*/
#define	ALT7		0X87E00		/* Alt 7		*/
#define	ALT8		0X87F00		/* Alt 8		*/
#define	ALT9		0X88000		/* Alt 9		*/
#define	ALT0		0X88100		/* Alt 0		*/

#define	CAS1		0XD7800		/* Ctrl Alt Shift 1	*/
#define	CAS2		0XD7900		/* Ctrl Alt Shift 2	*/
#define	CAS3		0XD7A00		/* Ctrl Alt Shift 3	*/
#define	CAS4		0XD7B00		/* Ctrl Alt Shift 4	*/
#define	CAS5		0XD7C00		/* Ctrl Alt Shift 5	*/
#define	CAS6		0XD7D00		/* Ctrl Alt Shift 6	*/
#define	CAS7		0XD7E00		/* Ctrl Alt Shift 7	*/
#define	CAS8		0XD7F00		/* Ctrl Alt Shift 8	*/
#define	CAS9		0XD8000		/* Ctrl Alt Shift 9	*/
#define	CAS0		0XD8100		/* Ctrl Alt Shift 0	*/

#define CURU		0X4800		/* Cursor Up		*/
#define CURD		0X5000		/* Cursor Down		*/
#define CURL		0X4B00		/* Cursor Left		*/
#define CURR		0X4D00		/* Cursor Right 	*/
#define PGU		0X4900		/* Page Up		*/
#define PGD		0X5100		/* Page Down		*/

#if 0
#define SHCURU		0X14838		/* Shift Cursor Up	*/
#define SHCURD		0X15032		/* Shift Cursor Down	*/
#define SHCURL		0X14B34		/* Shift Cursor Left	*/
#define SHCURR		0X14D36		/* Shift Cursor Right 	*/
#define SHPGU		0X14939		/* Shift Page Up	*/
#define SHPGD		0X15133		/* Shift Page Down	*/
#endif

#define SHCURU		0X14800		/* Shift Cursor Up	*/
#define SHCURD		0X15000		/* Shift Cursor Down	*/
#define SHCURL		0X14B00		/* Shift Cursor Left	*/
#define SHCURR		0X14D00		/* Shift Cursor Right 	*/
#define SHPGU		0X14900		/* Shift Page Up	*/
#define SHPGD		0X15100		/* Shift Page Down	*/

#define FIL96		0X97B00		/* Alt $		*/
#define	DOS_VISIT	0X97C00		/* Alt %		*/


#define	T_R_TOG		0X04700		/* Home			*/
/*			0X47700		   Ctrl Home		*/

#define HELP		0X3B00		/* F1			*/
#define F2		0X3C00          /* F2                   */

#define CODE_DATA_C	0X91E00		/* Alt A		*/
#define CODE_DATA_L	0X81E00		/* Alt a		*/

#define CODE_CHANGE_C	0X93000		/* Alt B		*/
#define CODE_CHANGE_L	0X83000		/* Alt b		*/

#define CMDQ_C		0X51011		/* Ctrl Q	n/u	*/
#define CMDQ_L		0X41011		/* Ctrl q	n/u	*/

#define CMDW_C		0X51117		/* Ctrl W	Clr LT	*/
#define CMDW_L		0X41117		/* Ctrl w		*/

#define CAW_C		0XD1100		/* Ctrl-Alt W	Clr Ylw	*/
#define CAW_L		0XC1100		/* Ctrl-Alt w		*/

#define CMDE_C		0X51205		/* Ctrl E	Flatten	*/
#define CMDE_L		0X41205		/* Ctrl e		*/

#define VCUR1_C		0X51E01		/* Ctrl A		*/
#define VCUR1_L		0X41E01		/* Ctrl a		*/

#define VCUR2_C		0X52004		/* Ctrl D		*/
#define VCUR2_L		0X42004		/* Ctrl d		*/

#define CMDF_C		0X52106		/* Ctrl F - N/U		*/
#define CMDF_L		0X42106		/* Ctrl f - N/U		*/

#define SET_CLOCK_C	0X92500		/* Alt K		*/
#define SET_CLOCK_L	0X82500		/* Alt k		*/

#define CODE_NX2_M_C	0X92C00		/* Alt Z		*/
#define CODE_NX2_M_L	0X82C00		/* Alt z		*/

#define CODE_NX2_P_C	0X92D00		/* Alt X		*/
#define CODE_NX2_P_L	0X82D00		/* Alt x		*/

#define EME_PREV	0X1333C		/* <			*/
#define EME_NEXT	0X1343E		/* >			*/

/* Following are diagnostic/service or unusual functions that are enabled by
 * the 'Scroll Lock' key.
 */
#define	BEACON_BOX	0X103C00	/* Scrl F2		*/
#define	DIAG_S		0X103D00	/* Scrl F3		*/
#define AF_FILTER_DESIGN 0X103E00	/* Scrl F4		*/
#define	XMT_EQ_DESIGN	0X103F00	/* Scrl F5		*/

#define	K_SF6		0X104000	/* Scrl F6		*/
#define	K_SF9		0X104300	/* Scrl F9		*/
#define	K_SF10		0X104400	/* Scrl F10		*/

#define AGC_DECAY_M	0X112247	/* Scrl G		*/
#define AGC_DECAY_P	0X112348	/* Scrl H		*/
#define AGC_DECAY_M_L	0X102267	/* Scrl g		*/
#define AGC_DECAY_P_L	0X102368	/* Scrl h		*/

#define	CWOFFSET_M	0X112E43	/* Scrl C		*/
#define	CWOFFSET_P	0X112F56	/* Scrl V		*/
#define	CWOFFSET_M_L	0X102E63	/* Scrl c		*/
#define	CWOFFSET_P_L	0X102F76	/* Scrl v		*/

#define	SIDETONE_LEV_M	 0X111F53	/* Scrl S		*/
#define	SIDETONE_LEV_P	 0X112044	/* Scrl D		*/
#define	SIDETONE_LEV_M_L 0X101F73	/* Scrl s		*/
#define	SIDETONE_LEV_P_L 0X102064	/* Scrl d		*/

#define XMT_POWER_M	0X11184F	/* Scrl O		*/
#define XMT_POWER_P	0X111950	/* Scrl P		*/
#define XMT_POWER_M_L	0X10186F	/* Scrl o		*/
#define XMT_POWER_P_L	0X101970	/* Scrl p		*/

#define DELAY_M		0X111245	/* Scrl E		*/
#define DELAY_P		0X111352	/* Scrl R		*/

#define	DO_QUIT		0X186B00	/* Scrl Alt F4		*/
#define	WARM_BOOT	0X1C6B00	/* Scrl Ctrl Alt F4	*/

/* Following are band change keys using the QST contest designator system.
 * For  432 MHz use Ctrl Alt D,
 * For 2304 MHz use Ctrl Alt F, etc
 */
#define BAND_50_A	0XC1E00
#define BAND_144_B	0XC3000
#define BAND_220_C	0XC2E00
#define BAND_432_D	0XC2000
#define BAND_902_9	0XC8000
#define BAND_1296_E	0XC1200
#define BAND_2304_F	0XC2100
#define BAND_3456_G	0XC2200
#define BAND_5760_H	0XC2300
#define BAND_10K_I	0XC1700
#define BAND_24K_J	0XC2400
#define BAND_47K_K	0XC2500
#define BAND_75K_L	0XC2600
#define BAND_119K_M	0XC3200
#define BAND_145K_N	0XC3100
#define BAND_241K_O	0XC1800
#define BAND_MEMO_1	0XC7800
#define BAND_MEMO_2	0XC7900
#define BAND_MEMO_3	0XC7A00
#define BAND_MEMO_4	0XC7B00
#define BAND_MEMO_5	0XC7C00
